package ru.dbotthepony.kstarbound.server.world

import ru.dbotthepony.kommons.arrays.Object2DArray
import ru.dbotthepony.kommons.core.KOptional
import ru.dbotthepony.kstarbound.world.CHUNK_SIZE
import ru.dbotthepony.kstarbound.world.ChunkPos
import ru.dbotthepony.kstarbound.world.api.AbstractCell
import ru.dbotthepony.kstarbound.world.entities.AbstractEntity
import ru.dbotthepony.kstarbound.world.entities.WorldObject
import java.util.concurrent.CompletableFuture

interface IChunkSource {
	fun getTiles(pos: ChunkPos): CompletableFuture<KOptional<Object2DArray<out AbstractCell>>>
	fun getEntities(pos: ChunkPos): CompletableFuture<KOptional<Collection<AbstractEntity>>>

	object Void : IChunkSource {
		override fun getTiles(pos: ChunkPos): CompletableFuture<KOptional<Object2DArray<out AbstractCell>>> {
			return CompletableFuture.completedFuture(KOptional.of(Object2DArray(CHUNK_SIZE, CHUNK_SIZE, AbstractCell.EMPTY)))
		}

		override fun getEntities(pos: ChunkPos): CompletableFuture<KOptional<Collection<AbstractEntity>>> {
			return CompletableFuture.completedFuture(KOptional.of(emptyList()))
		}
	}
}
